jQuery( document ).ready( function( $ ){

    // Shopping Cart Actions
    var shoppingCartItem        = $( "a.delete-cart" ),
        dialogBoxConfirm        = $( "#dialog-message" ),
        errorMessageDuration    = "10000",
        successMessageDuration  = "5000";

    // Events
    $( shoppingCartItem ).off().on( "click", function(){

        var cartID = $( this ).attr( "data-id" ),
            $row = $( this );

        var dialogTitle     = ecw_email_cart_js_vars.dialog_delete_warning,
            dialogYesBtn    = ecw_email_cart_js_vars.dialog_delete_yes_btn,
            dialogNoBtn     = ecw_email_cart_js_vars.dialog_delete_no_btn;

        dialogBoxConfirm.dialog({
            modal       : true,
            title       : dialogTitle,
            zIndex      : 10000,
            autoOpen    : true,
            width       : "auto",
            resizable   : false,
            buttons     : [
                {
                    text : dialogYesBtn,
                    click : function () {

                        $row.find( ".dashicons" ).removeClass( "dashicons-no" ).addClass( "spinner" ).css( { "margin":"0px", "visibility" : "visible", "float" : "none" } );

                        ecwBackendAjaxServices.ecwDeleteShoppingCartItem( cartID )
                            .done( function( data, textStatus, jqXHR ){

                                if( data.status == "success" ){

                                    ecwShoppingCartActions.deleteItem( $row );
                                    toastr.success( "", data.msg, { "closeButton" : true, "showDuration" : successMessageDuration } );

                                }else{

                                    toastr.error( "", data.msg, { "closeButton" : true, "showDuration" : errorMessageDuration } );
                                    console.log( "Failed" );
                                    console.log( data );

                                }

                            })
                            .fail(function( jqXHR, textStatus, errorThrown ){

                                console.log( "Failed" );
                                console.log( jqXHR );
                                console.log( "----------" );

                            });

                        $( this ).dialog( "close" );

                    }
                },
                {
                    text : dialogNoBtn,
                    click : function () {
                        $( this ).dialog( "close" );
                    }
                }
            ],
            close: function ( event, ui ) {

                $( this ).remove();

            }
        });
    });

    // Email Cart Form
    var dialogBoxEmailCartForm = $( "#email-cart-form" ),
        cID, sendersName, recipientName, recipientEmail, validate;

    // Events
    $( "body" ).off().on( "click", "#email_cart", function( e ){

        e.preventDefault();

        var dialogTitle         = ecw_email_cart_js_vars.dialog_title,
            dialogEmailButton   = ecw_email_cart_js_vars.dialog_button_email_cart;

        if ( window.ecwp_popup_effect_params !== undefined && window.ecwp_popup_effect_params !== null ) {

            dialogShow = { effect: ecwp_popup_effect_params[ 'popup_open_effect' ], duration: 400 };
            dialogHide = { effect: ecwp_popup_effect_params[ 'popup_close_effect' ], duration: 400 };

        } else {

            dialogShow = { effect: 'fade', duration: 10 };
            dialogHide = { effect: 'fade', duration: 10 };
        }

        dialogBoxEmailCartForm.dialog({
            dialogClass: "email-cart",
            modal: true,
            title: dialogTitle,
            zIndex: 10000,
            autoOpen: true,
            width: "auto",
            resizable: false,
            show: dialogShow,
            hide: dialogHide,
            buttons: [
                {
                    text : dialogEmailButton,
                    click : function () {

                        sendersName     = $( "#email-cart-form .form #sender_name" ).val();
                        recipientName   = $( "#email-cart-form .form #recipient_name" ).val();
                        recipientEmail  = $( "#email-cart-form .form #recipient_email" ).val();

                        // Nonce
                        var nonce = $( "#email-cart-form .form #email-cart-form-nonce-field" ).val();

                        validate = ecwShoppingCartActions.validateEmailCartForm( sendersName, recipientName, recipientEmail );

                        if( validate.sendersNameIsEmpty == false && validate.recipientNameIsEmpty == false && validate.emailIsEmpty == false && validate.emailIsValid == true ){

                            // show loading screen while in the process of sending an email to the recipient
                            ecwShoppingCartActions.showLoadingScreen();

                            ecwBackendAjaxServices.ecwSendShoppingCart( cID, sendersName, recipientName, recipientEmail, nonce )
                                .done( function( data, textStatus, jqXHR ){

                                    if( data.status == "success" ){

                                        ecwShoppingCartActions.shoppingCartSent();

                                    }else{

                                        console.log( data );
                                        ecwShoppingCartActions.shoppingCartErrorSending();

                                    }

                                })
                                .fail( function( jqXHR, textStatus, errorThrown ){
                                    console.log( "Failed" );
                                    console.log( jqXHR );
                                    console.log( textStatus );
                                    console.log( errorThrown );
                                    console.log( "----------" );
                                    ecwShoppingCartActions.shoppingCartErrorSending();

                                });

                        }else{

                            // Validate form
                            ecwShoppingCartActions.validateForm( validate );

                        }

                    }
                }
            ],
            close: function ( event, ui ) {

                // Hide any messages on the modal box
                ecwShoppingCartActions.hideMessages();

                $( "#email-cart-form .form" ).show();
                $( "div.email-cart" ).find( ".ui-dialog-title" ).show();
                $( "div.email-cart" ).find( "div.ui-dialog-buttonpane" ).show();
                $( this ).dialog( "close" );

            }
        });
    });

});
