/**
 * A function implementing the revealing module pattern to house all ajax request. It implements the ajax promise methodology
 * @return {Ajax Promise} promise it returns a promise, I promise that #lamejoke
 *
 * Info:
 * ajaxurl points to admin ajax url for ajax call purposes. Added by wp when script is wp enqueued
 */
var ecwBackendAjaxServices = function(){

    var ecwDeleteShoppingCartItem = function( cartID ){

            return jQuery.ajax({
                url         :   ajaxurl,
                type        :   "POST",
                data        :   { action:"ecwDeleteShoppingCartItem", cartID : cartID },
                dataType    :   "json"
            });

        },
        ecwSendShoppingCart = function( cid, sendersName, recipientName, recipientEmail, nonce ){

            return jQuery.ajax({
                url         :   front_end_ajax_object.ajaxurl,
                type        :   "POST",
                data        :   { action:"ecwSendEmailCartToRecipient", cid : cid, sendersName : sendersName, recipientName : recipientName, recipientEmail : recipientEmail, nonce : nonce },
                dataType    :   "json"
            });

        };

    return {
        ecwDeleteShoppingCartItem   :   ecwDeleteShoppingCartItem,
        ecwSendShoppingCart         :   ecwSendShoppingCart
    };

}();