var ecwShoppingCartActions = function(){

    var deleteItem = function( row ){

    		var itemsStatuses = jQuery( "ul.subsubsub li" );
    		var itemCartStatus = row.attr( "class" );
    			itemCartStatus = itemCartStatus.split( " " );
    			itemCartStatus = itemCartStatus[ 1 ];

    		jQuery( itemsStatuses ).each( function(){

    			var listClass = jQuery( this ).attr( "class" );

    			if( listClass == itemCartStatus || ( listClass == "all" && itemCartStatus != "trash" ) ){

    				var totalCount = jQuery( this ).find( "span.count" ).text();
    					totalCount = totalCount.substring( 1, totalCount.length-1 );
    					totalCount = totalCount - 1;

					jQuery( this ).find( "span.count" ).text( "(" + totalCount + ")" );

    			}

    		});

    		row.closest( "tr" ).css( "background", "#F387A2" ).fadeOut( 1500 );

        },
        showLoadingScreen = function(){

            jQuery( "div.email-cart #email-cart-form input[type=text]" ).removeClass( "error" );
            jQuery( "#email-cart-form .form" ).fadeOut( 300, function(){
                jQuery( "#email-cart-form .process" ).fadeIn( 300 );
            });
            jQuery( "div.email-cart div.ui-dialog-titlebar .ui-dialog-title" ).fadeOut( 300 );
            jQuery( "div.email-cart #email-cart-form + div.ui-dialog-buttonpane" ).fadeOut( 300 );

        },
        shoppingCartErrorSending = function(){

            ecwShoppingCartActions.hideMessages();
            jQuery( "#email-cart-form .error" ).show();

        },
        shoppingCartSent = function(){

            ecwShoppingCartActions.hideMessages();
            jQuery( "#email-cart-form .success" ).show();

        },
        validateEmailCartForm = function( senderName, recipientName, recipientEmail ){

            var results = { sendersNameIsEmpty: true, recipientNameIsEmpty: true, emailIsEmpty: true, emailIsValid: false };

            if( senderName.length !== 0 ){
                results.sendersNameIsEmpty = false;
            }
            if( recipientName.length !== 0 ){
                results.recipientNameIsEmpty = false;
            }
            if( recipientEmail.length !== 0 ){
                results.emailIsEmpty = false;
            }
            if( isValidEmail( recipientEmail ) ){
                results.emailIsValid = true;
            }

            return results;

        },
        isValidEmail = function( email ){

            var emailReg = new RegExp(/^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i);
            var valid = emailReg.test( email );

            return ( !valid ) ? false : true;

        },
        hideMessages = function(){

            // Reset values
            jQuery( "div.email-cart #email-cart-form input[type=text]" ).val( "" );

            // Remove error class
            jQuery( "div.email-cart #email-cart-form input[type=text]" ).removeClass( "error" );

            jQuery( "#email-cart-form .process" ).hide();
            jQuery( "#email-cart-form .success" ).hide();
            jQuery( "#email-cart-form .error" ).hide();

        },
        validateForm = function( validate ){

            var $cartForm = jQuery( "#email-cart-form .form" ),
                toastrErrors = [],
                errorMessageDuration = "1000000";

            if( validate.sendersNameIsEmpty == true ){

                $cartForm.find( "#sender_name" ).addClass( "error" );
                toastrErrors.push( ecw_email_cart_js_vars.sender_error_msg );

            }else{
                $cartForm.find( "#sender_name" ).removeClass( "error" );
            }

            if( validate.recipientNameIsEmpty == true ){

                $cartForm.find( "#recipient_name" ).addClass( "error" );
                toastrErrors.push( ecw_email_cart_js_vars.recipient_error_msg );

            }else{
                $cartForm.find( "#recipient_name" ).removeClass( "error" );
            }

            if( validate.emailIsEmpty == true || validate.emailIsValid == false ){

                $cartForm.find( "#recipient_email" ).addClass( "error" );
                toastrErrors.push( ecw_email_cart_js_vars.email_error_msg );

            }else{
                $cartForm.find( "#recipient_email" ).removeClass( "error" );
            }

            if ( toastrErrors.length > 0 ) {

                var str = "<ul>";
                for ( var i = 0 ; i < toastrErrors.length ; i++ ) {
                    str += "<li>&rarr; " + toastrErrors[ i ] + "</li>";
                }
                str += "</ul>";

                toastr.error( str , ecw_email_cart_js_vars.general_error_msg , { "closeButton" : true, "showDuration" : errorMessageDuration } );

            }

        };

    return {
        deleteItem                  :   deleteItem,
        showLoadingScreen           :   showLoadingScreen,
        shoppingCartErrorSending    :   shoppingCartErrorSending,
        shoppingCartSent            :   shoppingCartSent,
        validateEmailCartForm       :   validateEmailCartForm,
        isValidEmail                :   isValidEmail,
        hideMessages                :   hideMessages,
        validateForm                :   validateForm
    };

}();
