<?php
if ( !defined( 'WP_UNINSTALL_PLUGIN' ) ) exit();

/**
 * Function that houses the code that cleans up the plugin on un-installation.
 *
 * @since 1.3.0
 */
function ecwPluginCleanup(){

    global $wpdb;
    $cleanup = get_option( 'ecw_clean_plugin_options', 'no' );

    if( $cleanup == 'yes' ){

    	include_once( 'email-cart-for-woocommerce.options.php' );

    	$posts = $wpdb->get_results( "SELECT p.ID FROM $wpdb->posts p WHERE p.post_type = '" . ECW_CPT_NAME . "'", ARRAY_A );
        $postIDs = array();

        // Remove cron events
        foreach ( $posts as $post ) {

            $cartID = $post[ 'ID' ];
            $postIDs[] = $cartID;
            $expiryArgs = get_post_meta( $cartID, ECW_CART_EXPIRATION_CRON_ARGS, true );

            if( ! empty( $expiryArgs ) )
                wp_clear_scheduled_hook( ECW_CRON_HOOK, $expiryArgs );

        }

    	// Delete Entries.
        if( sizeof( $postIDs ) >= 1 ){

            $postIDs = implode( ', ', $postIDs );
            $wpdb->query( "DELETE FROM $wpdb->postmeta WHERE $wpdb->postmeta.post_id IN (" . $postIDs . ")" );
            $wpdb->query( "DELETE FROM $wpdb->posts WHERE ID IN (" . $postIDs . ")" );

        }

    	// Delete options.
        $wpdb->query( "DELETE FROM $wpdb->options WHERE option_name LIKE 'ecw\_%';" );

    	// Clear any cached data that has been removed
        wp_cache_flush();
        flush_rewrite_rules();
        
    }
}

if ( function_exists( 'is_multisite' ) && is_multisite() ) {

    global $wpdb;

    $blogIDs = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );

    foreach ( $blogIDs as $blog_id ) {

        switch_to_blog( $blog_id );
        ecwPluginCleanup();

    }

    restore_current_blog();

    return;

} else
    ecwPluginCleanup();